Share via


Environments - Create Or Update

Create or replace an existing environment. This operation can take a while to complete.

PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.DevTestLab/labs/{labName}/users/{userName}/environments/{name}?api-version=2018-09-15

URI Parameters

Name In Required Type Description
labName
path True

string

The name of the lab.

name
path True

string

The name of the environment.

resourceGroupName
path True

string

minLength: 1
maxLength: 90

The name of the resource group. The name is case insensitive.

subscriptionId
path True

string

minLength: 1

The ID of the target subscription.

userName
path True

string

The name of the user profile.

api-version
query True

string

minLength: 1

The API version to use for this operation.

Request Body

Name Type Description
location

string

The geo-location where the resource lives

properties.armTemplateDisplayName

string

The display name of the Azure Resource Manager template that produced the environment.

properties.deploymentProperties

EnvironmentDeploymentProperties

The deployment properties of the environment.

tags

object

Resource tags.

Responses

Name Type Description
200 OK

DtlEnvironment

Resource 'DtlEnvironment' update operation succeeded

201 Created

DtlEnvironment

Resource 'DtlEnvironment' create operation succeeded

Headers

  • Location: string
  • Retry-After: integer
Other Status Codes

ErrorResponse

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

Environments_CreateOrUpdate

Sample request

PUT https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/resourceGroupName/providers/Microsoft.DevTestLab/labs/{labName}/users/@me/environments/{environmentName}?api-version=2018-09-15

{
  "properties": {
    "deploymentProperties": {
      "armTemplateId": "/subscriptions/{subscriptionId}/resourceGroups/resourceGroupName/providers/Microsoft.DevTestLab/labs/{labName}/artifactSources/{artifactSourceName}/armTemplates/{armTemplateName}",
      "parameters": []
    }
  }
}

Sample response

{
  "name": "{environmentName}",
  "type": "Microsoft.DevTestLab/labs/users/environments",
  "id": "/subscriptions/{subscriptionId}/resourcegroups/resourceGroupName/providers/microsoft.devtestlab/labs/{labName}/users/{uniqueIdentifier}/environments/{environmentName}",
  "location": "{location}",
  "properties": {
    "createdByUser": "user@contoso.com",
    "deploymentProperties": {
      "armTemplateId": "/subscriptions/{subscriptionId}/resourcegroups/resourceGroupName/providers/microsoft.devtestlab/labs/{labName}/artifactSources/{artifactSourceName}/armTemplates/{armTemplateName}"
    },
    "provisioningState": "Succeeded",
    "uniqueIdentifier": "{uniqueIdentifier}"
  },
  "tags": {
    "tagName1": "tagValue1"
  }
}
{
  "name": "{environmentName}",
  "type": "Microsoft.DevTestLab/labs/users/environments",
  "id": "/subscriptions/{subscriptionId}/resourcegroups/resourceGroupName/providers/microsoft.devtestlab/labs/{labName}/users/{uniqueIdentifier}/environments/{environmentName}",
  "location": "{location}",
  "properties": {
    "createdByUser": "user@contoso.com",
    "deploymentProperties": {
      "armTemplateId": "/subscriptions/{subscriptionId}/resourcegroups/resourceGroupName/providers/microsoft.devtestlab/labs/{labName}/artifactSources/{artifactSourceName}/armTemplates/{armTemplateName}"
    },
    "provisioningState": "Creating",
    "uniqueIdentifier": "{uniqueIdentifier}"
  },
  "tags": {
    "tagName1": "tagValue1"
  }
}

Definitions

Name Description
ArmTemplateParameterProperties

Properties of an Azure Resource Manager template parameter.

createdByType

The type of identity that created the resource.

DtlEnvironment

An environment, which is essentially an ARM template deployment.

EnvironmentDeploymentProperties

Properties of an environment deployment.

ErrorAdditionalInfo

The resource management error additional info.

ErrorDetail

The error detail.

ErrorResponse

Error response

systemData

Metadata pertaining to creation and last modification of the resource.

ArmTemplateParameterProperties

Properties of an Azure Resource Manager template parameter.

Name Type Description
name

string

The name of the template parameter.

value

string

The value of the template parameter.

createdByType

The type of identity that created the resource.

Value Description
User
Application
ManagedIdentity
Key

DtlEnvironment

An environment, which is essentially an ARM template deployment.

Name Type Description
id

string

Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}

location

string

The geo-location where the resource lives

name

string

The name of the resource

properties.armTemplateDisplayName

string

The display name of the Azure Resource Manager template that produced the environment.

properties.createdByUser

string

The creator of the environment.

properties.deploymentProperties

EnvironmentDeploymentProperties

The deployment properties of the environment.

properties.provisioningState

string

The provisioning status of the resource.

properties.resourceGroupId

string

The identifier of the resource group containing the environment's resources.

properties.uniqueIdentifier

string

The unique immutable identifier of a resource (Guid).

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

tags

object

Resource tags.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

EnvironmentDeploymentProperties

Properties of an environment deployment.

Name Type Description
armTemplateId

string

The Azure Resource Manager template's identifier.

parameters

ArmTemplateParameterProperties[]

The parameters of the Azure Resource Manager template.

ErrorAdditionalInfo

The resource management error additional info.

Name Type Description
info

object

The additional info.

type

string

The additional info type.

ErrorDetail

The error detail.

Name Type Description
additionalInfo

ErrorAdditionalInfo[]

The error additional info.

code

string

The error code.

details

ErrorDetail[]

The error details.

message

string

The error message.

target

string

The error target.

ErrorResponse

Error response

Name Type Description
error

ErrorDetail

The error object.

systemData

Metadata pertaining to creation and last modification of the resource.

Name Type Description
createdAt

string (date-time)

The timestamp of resource creation (UTC).

createdBy

string

The identity that created the resource.

createdByType

createdByType

The type of identity that created the resource.

lastModifiedAt

string (date-time)

The timestamp of resource last modification (UTC)

lastModifiedBy

string

The identity that last modified the resource.

lastModifiedByType

createdByType

The type of identity that last modified the resource.